#!/usr/bin/perl -c

# $Id$

use strict;

sub {
    my ($rda, $plugintype, $datafile, $datatype) = @_;

    my %var;
    if ($rda->{plugvalue}{$plugintype}) {
        if (ref $rda->{plugvalue}{$plugintype} ne 'HASH') {
            return(0);
        } else {
            %var = %{$rda->{plugvalue}{$plugintype}};
        }
    } else {
        my $archive = $rda->archive() or return($rda->{plugvalue}{$plugintype} = 0);

        my ($index) = grep { /\.de1$/i } $archive->ls();

        $index or return($rda->{plugvalue}{$plugintype} = 0);
        
        my $filename = $archive->extract($index) or return($rda->{plugvalue}{$plugintype} = 0);

        my $resopen= open(my $h, $filename);

        unlink($filename);

        if(!$resopen) {
            return($rda->{plugvalue}{$plugintype} = 0);
        }

        %var = (); # ensure it is empty
        my $count_want_values = 6;
        while(my $line = <$h>) {
            chomp($line);
            if($line =~ /Flight date = (\d\d)-(\d\d)-\d\d(\d\d)/) {
                $var{year} = $3;
                $var{month} = $2;
                $var{day} = $1;
            } elsif ($line =~ /Time \[GMT\] = (\d\d):(\d\d):\d\d/) {
                $var{minute} = $2;
                $var{hour} = $1;
            } elsif($line =~ /Flight number = OH(\d{3})/) {
                $var{vol} = $1;
            }
            if (scalar(keys %var) == $count_want_values) { # to avoid to read the whole file !!
                last;
            }
        }

        close($h);
        if (scalar(keys %var) != $count_want_values) { #
            return($rda->{plugvalue}{$plugintype} = 0);
        }
        
        $rda->{plugvalue}{$plugintype} = { %var };
    }

    my $destfilename;
    for ($datafile) {
        /\.le1$/i and do { 
            $destfilename = sprintf(
                'cco%s%s%s%s%s.com',
                $var{year}, $var{month}, $var{day},
                $var{hour}, $var{minute},
            );
            $var{level} = 'niveau2';
        };
        
        /\.DE1$/i and do {
            $destfilename = sprintf(
                'cco%s%s%s%s%s.param',
                $var{year}, $var{month}, $var{day},
                $var{hour}, $var{minute},
            );
            $var{level} = 'niveau2';
        };

        /\.log$/i and do {
            $destfilename = sprintf(
                'cco%s%s%s%s%s.preval',
                $var{year}, $var{month}, $var{day},
                $var{hour}, $var{minute},
            );
            $var{level} = 'niveau1';
        };
        
        /\.cal$/i and do {
            $destfilename = sprintf(
                'cco%s%s%s%s%s.cal',
                $var{year}, $var{month}, $var{day},
                $var{hour}, $var{minute},
            );
            $var{level} = 'niveau1';
        };
        
        /\.raw$/i and do {
            $destfilename = sprintf(
                'cco%s%s%s.raw',
                $var{year}, $var{month}, $var{day},
            );
            $var{level} = 'niveau0';
        };
        
        /(...)\.dat$/i and do{
            $destfilename = sprintf(
                'cco%s%s%s_%s.dat',
                $var{year}, $var{month}, $var{day},
                uc($1),
            );
            $var{level} = 'niveau0';
        };
        
        /\.mes$/i and do {
            $destfilename = sprintf(
                'cco%s%s%s.vol%s',
                $var{year}, $var{month}, $var{day},
                $var{vol},
            );
            $var{level} = 'cr_vol_voemel';
        };

    }
    
    $destfilename or return(0);

    return (1, 'filename', $destfilename, %var);
}
